## highway 0.12.2%2Bgit20210722

=== CMakeLists.txt ===
# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.10)

# Set PIE flags for POSITION_INDEPENDENT_CODE targets, added in 3.14.
if(POLICY CMP0083)
  cmake_policy(SET CMP0083 NEW)
endif()

project(hwy VERSION 0.12.2)  # Keep in sync with highway.h version

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED YES)

# Enabled PIE binaries by default if supported.
include(CheckPIESupported OPTIONAL RESULT_VARIABLE CHECK_PIE_SUPPORTED)
if(CHECK_PIE_SUPPORTED)
  check_pie_supported(LANGUAGES CXX)
  if(CMAKE_CXX_LINK_PIE_SUPPORTED)
    set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
  endif()
endif()

include(GNUInstallDirs)

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for ARMv7 with NEON?")

include(CheckCXXSourceCompiles)
check_cxx_source_compiles(
   "int main() {
      #if !defined(__EMSCRIPTEN__)
      static_assert(false, \"__EMSCRIPTEN__ is not defined\");
      #endif
      return 0;
    }"
  HWY_EMSCRIPTEN
)

set(HWY_CONTRIB_SOURCES
    hwy/contrib/image/image.cc
    hwy/contrib/image/image.h
    hwy/contrib/math/math-inl.h
)

set(HWY_SOURCES
    hwy/aligned_allocator.cc
    hwy/aligned_allocator.h
    hwy/base.h
    hwy/cache_control.h
    hwy/detect_compiler_arch.h  # private
    hwy/detect_targets.h  # private
    hwy/foreach_target.h
    hwy/highway.h
    hwy/nanobenchmark.cc
    hwy/nanobenchmark.h
    hwy/ops/arm_neon-inl.h
    hwy/ops/arm_sve-inl.h
    hwy/ops/generic_ops-inl.h
    hwy/ops/scalar-inl.h
    hwy/ops/set_macros-inl.h
    hwy/ops/shared-inl.h
    hwy/ops/wasm_128-inl.h
    hwy/ops/x86_128-inl.h
    hwy/ops/x86_256-inl.h
    hwy/ops/x86_512-inl.h
    hwy/targets.cc
    hwy/targets.h
    hwy/tests/test_util-inl.h
)

if (MSVC)
  # TODO(janwas): add flags
else()
  set(HWY_FLAGS
    # Avoid changing binaries based on the current time and date.
    -Wno-builtin-macro-redefined
    -D__DATE__="redacted"
    -D__TIMESTAMP__="redacted"
    -D__TIME__="redacted"

    # Optimizations
    -fmerge-all-constants

    # Warnings
    -Wall
    -Wextra
    -Wformat-security
    -Wno-unused-function
    -Wnon-virtual-dtor
    -Woverloaded-virtual
    -Wvla
  )

  if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    list(APPEND HWY_FLAGS
      -Wfloat-overflow-conversion
      -Wfloat-zero-conversion
      -Wfor-loop-analysis
      -Wgnu-redeclared-enum
      -Winfinite-recursion
      -Wself-assign
      -Wstring-conversion
      -Wtautological-overlap-compare
      -Wthread-safety-analysis
      -Wundefined-func-template

      -fno-cxx-exceptions
      -fno-slp-vectorize
      -fno-vectorize

      # Use color in messages
      -fdiagnostics-show-option -fcolor-diagnostics
    )
    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 6.0)
      list(APPEND HWY_FLAGS -Wc++2a-extensions)
    endif()
  endif()

  if (WIN32)
    list(APPEND HWY_FLAGS
      -Wno-c++98-compat-pedantic
      -Wno-cast-align
      -Wno-double-promotion
      -Wno-float-equal
      -Wno-format-nonliteral
      -Wno-global-constructors
      -Wno-language-extension-token
      -Wno-missing-prototypes
      -Wno-shadow
      -Wno-shadow-field-in-constructor
      -Wno-sign-conversion
      -Wno-unused-member-function
      -Wno-unused-template
      -Wno-used-but-marked-unused
      -Wno-zero-as-null-pointer-constant
    )
  else()
    list(APPEND HWY_FLAGS
      -fmath-errno
      -fno-exceptions
    )
  endif()

  if (HWY_CMAKE_ARM7)
    list(APPEND HWY_FLAGS
      -march=armv7-a
      -mfpu=neon-vfpv4
      -mfloat-abi=hard  # must match the toolchain specified as CXX=
      -mfp16-format=ieee  # required for vcvt_f32_f16
    )
  endif()  # HWY_CMAKE_ARM7

endif()  # !MSVC

add_library(hwy STATIC ${HWY_SOURCES})
target_compile_options(hwy PRIVATE ${HWY_FLAGS})
set_property(TARGET hwy PROPERTY POSITION_INDEPENDENT_CODE ON)
target_include_directories(hwy PUBLIC ${CMAKE_CURRENT_LIST_DIR})

add_library(hwy_contrib STATIC ${HWY_CONTRIB_SOURCES})
target_compile_options(hwy_contrib PRIVATE ${HWY_FLAGS})
set_property(TARGET hwy_contrib PROPERTY POSITION_INDEPENDENT_CODE ON)
target_include_directories(hwy_contrib PUBLIC ${CMAKE_CURRENT_LIST_DIR})

# -------------------------------------------------------- hwy_list_targets
# Generate a tool to print the compiled-in targets as defined by the current
# flags. This tool will print to stderr at build time, after building hwy.
add_executable(hwy_list_targets hwy/tests/list_targets.cc)
target_compile_options(hwy_list_targets PRIVATE ${HWY_FLAGS})
target_include_directories(hwy_list_targets PRIVATE
  $<TARGET_PROPERTY:hwy,INCLUDE_DIRECTORIES>)
# TARGET_FILE always returns the path to executable
# Naked target also not always could be run (due to the lack of '.\' prefix)
# Thus effective command to run should contain the full path
# and emulator prefix (if any).
add_custom_command(TARGET hwy POST_BUILD
    COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:hwy_list_targets> || (exit 0))

# --------------------------------------------------------
# The following sections are skipped if this project is added via
# add_subdirectory into parent project (i.e. used as library).
# Those sections contain artifacts that are not required for building
# parent project: tests, examples, benchmarks and installation.
# --------------------------------------------------------
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

# -------------------------------------------------------- install library
install(TARGETS hwy
  DESTINATION "${CMAKE_INSTALL_LIBDIR}")
# Install all the headers keeping the relative path to the current directory
# when installing them.
foreach (source ${HWY_SOURCES})
  if ("${source}" MATCHES "\.h$")
    get_filename_component(dirname "${source}" DIRECTORY)
    install(FILES "${source}"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${dirname}")
  endif()
endforeach()

install(TARGETS hwy_contrib
  DESTINATION "${CMAKE_INSTALL_LIBDIR}")
# Install all the headers keeping the relative path to the current directory
# when installing them.
foreach (source ${HWY_CONTRIB_SOURCES})
  if ("${source}" MATCHES "\.h$")
    get_filename_component(dirname "${source}" DIRECTORY)
    install(FILES "${source}"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${dirname}")
  endif()
endforeach()

# Add a pkg-config file for libhwy and the contrib/test libraries.
set(HWY_LIBRARY_VERSION "${CMAKE_PROJECT_VERSION}")
foreach (pc libhwy.pc libhwy-contrib.pc libhwy-test.pc)
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${pc}.in" "${pc}" @ONLY)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${pc}"
      DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
endforeach()

# -------------------------------------------------------- Examples

# Avoids mismatch between GTest's static CRT and our dynamic.
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

# Programming exercise with integrated benchmark
add_executable(hwy_benchmark hwy/examples/benchmark.cc)
target_sources(hwy_benchmark PRIVATE
    hwy/nanobenchmark.cc
    hwy/nanobenchmark.h)
# Try adding either -DHWY_COMPILE_ONLY_SCALAR or -DHWY_COMPILE_ONLY_STATIC to
# observe the difference in targets printed.
target_compile_options(hwy_benchmark PRIVATE ${HWY_FLAGS})
target_link_libraries(hwy_benchmark hwy)
set_target_properties(hwy_benchmark
    PROPERTIES RUNTIME_OUTPUT_DIRECTORY "examples/")

# -------------------------------------------------------- Tests

include(CTest)

if(BUILD_TESTING)
enable_testing()
include(GoogleTest)

set(HWY_SYSTEM_GTEST OFF CACHE BOOL "Use pre-installed googletest?")
if(HWY_SYSTEM_GTEST)
find_package(GTest REQUIRED)
else()
# Download and unpack googletest at configure time
configure_file(CMakeLists.txt.in googletest-download/CMakeLists.txt)
execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if(result)
  message(FATAL_ERROR "CMake step for googletest failed: ${result}")
endif()
execute_process(COMMAND ${CMAKE_COMMAND} --build .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if(result)
  message(FATAL_ERROR "Build step for googletest failed: ${result}")
endif()

# Prevent overriding the parent project's compiler/linker
# settings on Windows
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

# Add googletest directly to our build. This defines
# the gtest and gtest_main targets.
add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
                 ${CMAKE_CURRENT_BINARY_DIR}/googletest-build
                 EXCLUDE_FROM_ALL)

# The gtest/gtest_main targets carry header search path
# dependencies automatically when using CMake 2.8.11 or
# later. Otherwise we have to add them here ourselves.
if (CMAKE_VERSION VERSION_LESS 2.8.11)
  include_directories("${gtest_SOURCE_DIR}/include")
endif()
endif() # HWY_SYSTEM_GTEST

set(HWY_TEST_FILES
  hwy/contrib/image/image_test.cc
  # hwy/contrib/math/math_test.cc
  hwy/aligned_allocator_test.cc
  hwy/base_test.cc
  hwy/highway_test.cc
  hwy/targets_test.cc
  hwy/examples/skeleton_test.cc
  hwy/tests/arithmetic_test.cc
  hwy/tests/blockwise_test.cc
  hwy/tests/combine_test.cc
  hwy/tests/compare_test.cc
  hwy/tests/convert_test.cc
  hwy/tests/crypto_test.cc
  hwy/tests/logical_test.cc
  hwy/tests/mask_test.cc
  hwy/tests/memory_test.cc
  hwy/tests/swizzle_test.cc
  hwy/tests/test_util_test.cc
)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests)
foreach (TESTFILE IN LISTS HWY_TEST_FILES)
  # The TESTNAME is the name without the extension or directory.
  get_filename_component(TESTNAME ${TESTFILE} NAME_WE)
  add_executable(${TESTNAME} ${TESTFILE})
  target_compile_options(${TESTNAME} PRIVATE ${HWY_FLAGS})
  # Test all targets, not just the best/baseline. This changes the default
  # policy to all-attainable; note that setting -DHWY_COMPILE_* directly can
  # cause compile errors because only one may be set, and other CMakeLists.txt
  # that include us may set them.
  target_compile_options(${TESTNAME} PRIVATE -DHWY_IS_TEST=1)

  if(HWY_SYSTEM_GTEST)
    target_link_libraries(${TESTNAME} hwy hwy_contrib GTest::GTest GTest::Main)
  else()
    target_link_libraries(${TESTNAME} hwy hwy_contrib gtest gtest_main)
  endif()
  # Output test targets in the test directory.
  set_target_properties(${TESTNAME} PROPERTIES PREFIX "tests/")

  if (HWY_EMSCRIPTEN)
    set_target_properties(${TESTNAME} PROPERTIES LINK_FLAGS "-s SINGLE_FILE=1")
  endif()

  if(${CMAKE_VERSION} VERSION_LESS "3.10.3")
    gtest_discover_tests(${TESTNAME} TIMEOUT 60)
  else ()
    gtest_discover_tests(${TESTNAME} DISCOVERY_TIMEOUT 60)
  endif ()
endforeach ()

# The skeleton test uses the skeleton library code.
target_sources(skeleton_test PRIVATE hwy/examples/skeleton.cc)

endif() # BUILD_TESTING

endif() # CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR

## highway 0.12.2+git20210722

=== debian/changelog ===
highway (0.12.2+git20210722-1~mx21+1) mx; urgency=medium

  * Initial packaging for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sun, 25 Jul 2021 00:41:13 -0400

highway (0.12.2-1) UNRELEASED; urgency=medium

  * fix scalar-only test and Windows macro conflict with Load/StoreFence
  * replace deprecated wasm intrinsics

 -- Jan Wassenberg <janwas@google.com>  Mon, 31 May 2021 16:00:00 +0200

highway (0.12.1-1) UNRELEASED; urgency=medium

  * doc updates, ARM GCC support, fix s390/ppc, complete partial vectors
  * fix warnings, faster ARM div/sqrt, separate hwy_contrib library
  * add Abs(i64)/FirstN/Pause, enable AVX2 on MSVC

 -- Jan Wassenberg <janwas@google.com>  Wed, 19 May 2021 15:00:00 +0200

highway (0.12.0-1) UNRELEASED; urgency=medium

  * Add Shift*8, Compress16, emulated Scatter/Gather, StoreInterleaved3/4
  * Remove deprecated HWY_*_LANES, deprecate HWY_GATHER_LANES
  * Proper IEEE rounding, reduce libstdc++ usage, inlined math

 -- Jan Wassenberg <janwas@google.com>  Thu, 15 Apr 2021 20:00:00 +0200

highway (0.11.1-1) UNRELEASED; urgency=medium

  * Fix clang7 asan error, finish f16 conversions and add test

 -- Jan Wassenberg <janwas@google.com>  Thu, 25 Feb 2021 16:00:00 +0200

highway (0.11.0-1) UNRELEASED; urgency=medium

  * Add RVV+mask logical ops, allow Shl/ShiftLeftSame on all targets, more math

 -- Jan Wassenberg <janwas@google.com>  Thu, 18 Feb 2021 20:00:00 +0200

highway (0.7.0-1) UNRELEASED; urgency=medium

  * Added API stability notice, Compress[Store], contrib/, SignBit, CopySign

 -- Jan Wassenberg <janwas@google.com>  Tue, 5 Jan 2021 17:00:00 +0200

highway (0.1-1) UNRELEASED; urgency=medium

  * Initial debian package.

 -- Alex Deymo <deymo@google.com>  Mon, 19 Oct 2020 16:48:07 +0200

=== debian/control ===
Source: highway
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: JPEG XL Maintainers <jpegxl@google.com>
Section: misc
Priority: optional
Standards-Version: 3.9.8
Build-Depends: cmake,
               debhelper (>= 9),
               libgtest-dev
Homepage: https://github.com/google/highway

Package: libhwy-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: Efficient and performance-portable SIMD wrapper (developer files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the development files. There's no runtime library
 since most of Highway is implemented in headers and only a very small
 static library is needed.

## highway 0.15.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
   cmake_policy(SET CMP0083 NEW)
 endif()
 
-project(hwy VERSION 0.12.2)  # Keep in sync with highway.h version
+project(hwy VERSION 0.15.0)  # Keep in sync with highway.h version
 
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_EXTENSIONS OFF)
@@ -41,6 +41,12 @@
 endif()
 
 set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for ARMv7 with NEON?")
+
+# Unconditionally adding -Werror risks breaking the build when new warnings
+# arise due to compiler/platform changes. Enable this in CI/tests.
+set(HWY_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Add -Werror flag?")
+
+set(HWY_EXAMPLES_TESTS_INSTALL ON CACHE BOOL "Build examples, tests, install?")
 
 include(CheckCXXSourceCompiles)
 check_cxx_source_compiles(
@@ -54,9 +60,11 @@
 )
 
 set(HWY_CONTRIB_SOURCES
+    hwy/contrib/dot/dot-inl.h
     hwy/contrib/image/image.cc
     hwy/contrib/image/image.h
     hwy/contrib/math/math-inl.h
+    hwy/contrib/sort/sort-inl.h
 )
 
 set(HWY_SOURCES
@@ -82,7 +90,13 @@
     hwy/ops/x86_512-inl.h
     hwy/targets.cc
     hwy/targets.h
+)
+
+set(HWY_TEST_SOURCES
+    hwy/tests/hwy_gtest.h
     hwy/tests/test_util-inl.h
+    hwy/tests/test_util.cc
+    hwy/tests/test_util.h
 )
 
 if (MSVC)
@@ -101,11 +115,11 @@
     # Warnings
     -Wall
     -Wextra
-    -Wformat-security
-    -Wno-unused-function
+    # These are not included in Wall nor Wextra:
+    -Wconversion
+    -Wsign-conversion
+    -Wvla
     -Wnon-virtual-dtor
-    -Woverloaded-virtual
-    -Wvla
   )
 
   if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
@@ -134,29 +148,34 @@
   endif()
 
   if (WIN32)
+    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
+      list(APPEND HWY_FLAGS
+        -Wno-global-constructors
+        -Wno-language-extension-token
+        -Wno-used-but-marked-unused
+        -Wno-shadow-field-in-constructor
+        -Wno-unused-member-function
+        -Wno-unused-template
+        -Wno-c++98-compat-pedantic
+        -Wno-used-but-marked-unused
+        -Wno-zero-as-null-pointer-constant
+      )
+    endif()
+
     list(APPEND HWY_FLAGS
-      -Wno-c++98-compat-pedantic
       -Wno-cast-align
       -Wno-double-promotion
       -Wno-float-equal
       -Wno-format-nonliteral
-      -Wno-global-constructors
-      -Wno-language-extension-token
-      -Wno-missing-prototypes
       -Wno-shadow
-      -Wno-shadow-field-in-constructor
       -Wno-sign-conversion
-      -Wno-unused-member-function
-      -Wno-unused-template
-      -Wno-used-but-marked-unused
-      -Wno-zero-as-null-pointer-constant
     )
   else()
     list(APPEND HWY_FLAGS
       -fmath-errno
       -fno-exceptions
     )
-  endif()
+  endif()  # WIN32
 
   if (HWY_CMAKE_ARM7)
     list(APPEND HWY_FLAGS
@@ -167,6 +186,10 @@
     )
   endif()  # HWY_CMAKE_ARM7
 
+  if (HWY_WARNINGS_ARE_ERRORS)
+    list(APPEND HWY_FLAGS -Werror)
+  endif()
+
 endif()  # !MSVC
 
 add_library(hwy STATIC ${HWY_SOURCES})
@@ -178,28 +201,31 @@
 target_compile_options(hwy_contrib PRIVATE ${HWY_FLAGS})
 set_property(TARGET hwy_contrib PROPERTY POSITION_INDEPENDENT_CODE ON)
 target_include_directories(hwy_contrib PUBLIC ${CMAKE_CURRENT_LIST_DIR})
+
+add_library(hwy_test STATIC ${HWY_TEST_SOURCES})
+target_compile_options(hwy_test PRIVATE ${HWY_FLAGS})
+set_property(TARGET hwy_test PROPERTY POSITION_INDEPENDENT_CODE ON)
+target_include_directories(hwy_test PUBLIC ${CMAKE_CURRENT_LIST_DIR})
 
 # -------------------------------------------------------- hwy_list_targets
 # Generate a tool to print the compiled-in targets as defined by the current
 # flags. This tool will print to stderr at build time, after building hwy.
 add_executable(hwy_list_targets hwy/tests/list_targets.cc)
 target_compile_options(hwy_list_targets PRIVATE ${HWY_FLAGS})
+target_link_libraries(hwy_list_targets hwy)
 target_include_directories(hwy_list_targets PRIVATE
   $<TARGET_PROPERTY:hwy,INCLUDE_DIRECTORIES>)
 # TARGET_FILE always returns the path to executable
 # Naked target also not always could be run (due to the lack of '.\' prefix)
 # Thus effective command to run should contain the full path
 # and emulator prefix (if any).
-add_custom_command(TARGET hwy POST_BUILD
+add_custom_command(TARGET hwy_list_targets POST_BUILD
     COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:hwy_list_targets> || (exit 0))
 
 # --------------------------------------------------------
-# The following sections are skipped if this project is added via
-# add_subdirectory into parent project (i.e. used as library).
-# Those sections contain artifacts that are not required for building
-# parent project: tests, examples, benchmarks and installation.
-# --------------------------------------------------------
-if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
+# Allow skipping the following sections for projects that do not need them:
+# tests, examples, benchmarks and installation.
+if (HWY_EXAMPLES_TESTS_INSTALL)
 
 # -------------------------------------------------------- install library
 install(TARGETS hwy
@@ -219,6 +245,18 @@
 # Install all the headers keeping the relative path to the current directory
 # when installing them.
 foreach (source ${HWY_CONTRIB_SOURCES})
+  if ("${source}" MATCHES "\.h$")
+    get_filename_component(dirname "${source}" DIRECTORY)
+    install(FILES "${source}"
+        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${dirname}")
+  endif()
+endforeach()
+
+install(TARGETS hwy_test
+  DESTINATION "${CMAKE_INSTALL_LIBDIR}")
+# Install all the headers keeping the relative path to the current directory
+# when installing them.
+foreach (source ${HWY_TEST_SOURCES})
   if ("${source}" MATCHES "\.h$")
     get_filename_component(dirname "${source}" DIRECTORY)
     install(FILES "${source}"
@@ -297,8 +335,12 @@
 endif() # HWY_SYSTEM_GTEST
 
 set(HWY_TEST_FILES
+  hwy/contrib/dot/dot_test.cc
   hwy/contrib/image/image_test.cc
+  # Disabled due to SIGILL in clang7 debug build during gtest discovery phase,
+  # not reproducible locally. Still tested via bazel build.
   # hwy/contrib/math/math_test.cc
+  hwy/contrib/sort/sort_test.cc
   hwy/aligned_allocator_test.cc
   hwy/base_test.cc
   hwy/highway_test.cc
@@ -327,30 +369,3 @@
   # policy to all-attainable; note that setting -DHWY_COMPILE_* directly can
   # cause compile errors because only one may be set, and other CMakeLists.txt
   # that include us may set them.
-  target_compile_options(${TESTNAME} PRIVATE -DHWY_IS_TEST=1)
-
-  if(HWY_SYSTEM_GTEST)
-    target_link_libraries(${TESTNAME} hwy hwy_contrib GTest::GTest GTest::Main)
-  else()
-    target_link_libraries(${TESTNAME} hwy hwy_contrib gtest gtest_main)
-  endif()
-  # Output test targets in the test directory.
-  set_target_properties(${TESTNAME} PROPERTIES PREFIX "tests/")
-
-  if (HWY_EMSCRIPTEN)
-    set_target_properties(${TESTNAME} PROPERTIES LINK_FLAGS "-s SINGLE_FILE=1")
-  endif()
-
-  if(${CMAKE_VERSION} VERSION_LESS "3.10.3")
-    gtest_discover_tests(${TESTNAME} TIMEOUT 60)
-  else ()
-    gtest_discover_tests(${TESTNAME} DISCOVERY_TIMEOUT 60)
-  endif ()
-endforeach ()
-
-# The skeleton test uses the skeleton library code.
-target_sources(skeleton_test PRIVATE hwy/examples/skeleton.cc)
-
-endif() # BUILD_TESTING
-
-endif() # CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR

=== debian/changelog ===
highway (0.15.0-5) unstable; urgency=medium

  * d/rules: Clarify that we only ship static libs for now
  * d/control: Add missing Rules-Requires-Root: no
  * d/patches: Remove compilation error on GNU/Hurd
  * d/rules: Set HWY_CMAKE_ARM7 to OFF. Closes: #1003218
  * d/patches: Fix compilation error on riscv64

 -- Mathieu Malaterre <malat@debian.org>  Tue, 11 Jan 2022 14:52:28 +0100

highway (0.15.0-4) unstable; urgency=medium

  * d/docs: Create new highway-doc package
  * d/rules: Do not set HWY_CMAKE_ARM7:ON for arm64
  * d/rules: Prefer building using cmake+ninja
  * d/rules: Properly setup HWY_CMAKE_ARM7 on armhf. Closes: #1003218

 -- Mathieu Malaterre <malat@debian.org>  Thu, 06 Jan 2022 15:21:05 +0100

highway (0.15.0-3) unstable; urgency=medium

  * d/rules: Fix typo in cmake armhf/neon option
  * d/rules: Make sure to use neon extension on arm64
  * d/control: libhwy-dev could be marked Multi-Arch: same

 -- Mathieu Malaterre <malat@debian.org>  Thu, 06 Jan 2022 13:59:37 +0100

highway (0.15.0-2) unstable; urgency=medium

  * Upload to unstable
  * d/rules: Make sure to compile without warnings
  * d/rules: Start using arm7 neon extension
  * d/patches: Prefer default gcc c++ version

 -- Mathieu Malaterre <malat@debian.org>  Tue, 04 Jan 2022 15:45:40 +0100

highway (0.15.0-1) experimental; urgency=medium

  * Initial release (Closes: #1000984)

 -- Mathieu Malaterre <malat@debian.org>  Thu, 02 Dec 2021 21:42:02 +0100

=== debian/control ===
Source: highway
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: cmake (>= 3.13), debhelper (>= 10), libgtest-dev, ninja-build
Standards-Version: 4.6.0
Homepage: https://github.com/google/highway
Vcs-Git: https://salsa.debian.org/debian-phototools-team/highway.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
Rules-Requires-Root: no

Package: libhwy-dev
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Multi-Arch: same
Description: Efficient and performance-portable SIMD wrapper (developer files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the development files. There's no runtime library
 since most of Highway is implemented in headers and only a very small
 static library is needed.

Package: highway-doc
Architecture: all
Section: doc
Depends: doc-base, ${misc:Depends}
Description: Efficient and performance-portable SIMD wrapper (developer files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the documentation files.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=cmake+ninja

ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),armhf))
  # https://github.com/google/highway/issues/495
  CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=OFF
endif

CMAKE_EXTRA_FLAGS += \
 -DBUILD_SHARED_LIBS:BOOL=OFF \
 -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
 -DHWY_SYSTEM_GTEST:BOOL=ON

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_compress-indep:
	# do not compress .pdf/.md files for documentation
	dh_compress -X.md -X.pdf

## highway 0.16.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,11 +19,13 @@
   cmake_policy(SET CMP0083 NEW)
 endif()
 
-project(hwy VERSION 0.15.0)  # Keep in sync with highway.h version
-
-set(CMAKE_CXX_STANDARD 11)
+project(hwy VERSION 0.16.0)  # Keep in sync with highway.h version
+
+# Directly define the ABI version from the cmake project() version values:
+set(LIBRARY_VERSION "${hwy_VERSION}")
+set(LIBRARY_SOVERSION ${hwy_VERSION_MAJOR})
+
 set(CMAKE_CXX_EXTENSIONS OFF)
-set(CMAKE_CXX_STANDARD_REQUIRED YES)
 
 # Enabled PIE binaries by default if supported.
 include(CheckPIESupported OPTIONAL RESULT_VARIABLE CHECK_PIE_SUPPORTED)
@@ -40,13 +42,14 @@
   set(CMAKE_BUILD_TYPE RelWithDebInfo)
 endif()
 
-set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for ARMv7 with NEON?")
+set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for ARMv7 with NEON (requires vfpv4)?")
 
 # Unconditionally adding -Werror risks breaking the build when new warnings
 # arise due to compiler/platform changes. Enable this in CI/tests.
 set(HWY_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Add -Werror flag?")
 
-set(HWY_EXAMPLES_TESTS_INSTALL ON CACHE BOOL "Build examples, tests, install?")
+set(HWY_ENABLE_EXAMPLES ON CACHE BOOL "Build examples")
+set(HWY_ENABLE_INSTALL ON CACHE BOOL "Install library")
 
 include(CheckCXXSourceCompiles)
 check_cxx_source_compiles(
@@ -64,7 +67,32 @@
     hwy/contrib/image/image.cc
     hwy/contrib/image/image.h
     hwy/contrib/math/math-inl.h
-    hwy/contrib/sort/sort-inl.h
+    hwy/contrib/sort/disabled_targets.h
+    hwy/contrib/sort/shared-inl.h
+    hwy/contrib/sort/sorting_networks-inl.h
+    hwy/contrib/sort/traits-inl.h
+    hwy/contrib/sort/traits128-inl.h
+    hwy/contrib/sort/vqsort-inl.h
+    hwy/contrib/sort/vqsort.cc
+    hwy/contrib/sort/vqsort.h
+    hwy/contrib/sort/vqsort_128a.cc
+    hwy/contrib/sort/vqsort_128d.cc
+    hwy/contrib/sort/vqsort_f32a.cc
+    hwy/contrib/sort/vqsort_f32d.cc
+    hwy/contrib/sort/vqsort_f64a.cc
+    hwy/contrib/sort/vqsort_f64d.cc
+    hwy/contrib/sort/vqsort_i16a.cc
+    hwy/contrib/sort/vqsort_i16d.cc
+    hwy/contrib/sort/vqsort_i32a.cc
+    hwy/contrib/sort/vqsort_i32d.cc
+    hwy/contrib/sort/vqsort_i64a.cc
+    hwy/contrib/sort/vqsort_i64d.cc
+    hwy/contrib/sort/vqsort_u16a.cc
+    hwy/contrib/sort/vqsort_u16d.cc
+    hwy/contrib/sort/vqsort_u32a.cc
+    hwy/contrib/sort/vqsort_u32d.cc
+    hwy/contrib/sort/vqsort_u64a.cc
+    hwy/contrib/sort/vqsort_u64d.cc
 )
 
 set(HWY_SOURCES
@@ -76,6 +104,7 @@
     hwy/detect_targets.h  # private
     hwy/foreach_target.h
     hwy/highway.h
+    hwy/highway_export.h
     hwy/nanobenchmark.cc
     hwy/nanobenchmark.h
     hwy/ops/arm_neon-inl.h
@@ -192,20 +221,59 @@
 
 endif()  # !MSVC
 
-add_library(hwy STATIC ${HWY_SOURCES})
+# By default prefer STATIC build (legacy behavior)
+option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
+option(HWY_FORCE_STATIC_LIBS "Ignore BUILD_SHARED_LIBS" OFF)
+# only expose shared/static options to advanced users:
+mark_as_advanced(BUILD_SHARED_LIBS)
+mark_as_advanced(HWY_FORCE_STATIC_LIBS)
+# Define visibility settings globally:
+set(CMAKE_CXX_VISIBILITY_PRESET hidden)
+set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
+
+# Copy-cat "add_library" logic + add override.
+set(HWY_LIBRARY_TYPE "SHARED")
+if (NOT BUILD_SHARED_LIBS OR HWY_FORCE_STATIC_LIBS)
+  set(HWY_LIBRARY_TYPE "STATIC")
+endif()
+
+# This preprocessor define will drive the build, also used in the *.pc files:
+if("${HWY_LIBRARY_TYPE}" STREQUAL "SHARED")
+  set(DLLEXPORT_TO_DEFINE "HWY_SHARED_DEFINE")
+else()
+  set(DLLEXPORT_TO_DEFINE "HWY_STATIC_DEFINE")
+endif()
+
+add_library(hwy ${HWY_LIBRARY_TYPE} ${HWY_SOURCES})
+target_compile_definitions(hwy PUBLIC "${DLLEXPORT_TO_DEFINE}")
 target_compile_options(hwy PRIVATE ${HWY_FLAGS})
 set_property(TARGET hwy PROPERTY POSITION_INDEPENDENT_CODE ON)
+set_target_properties(hwy PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
 target_include_directories(hwy PUBLIC ${CMAKE_CURRENT_LIST_DIR})
-
-add_library(hwy_contrib STATIC ${HWY_CONTRIB_SOURCES})
+target_compile_features(hwy PUBLIC cxx_std_11)
+set_target_properties(hwy PROPERTIES
+  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
+# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
+if(UNIX AND NOT APPLE)
+  set_property(TARGET hwy APPEND_STRING PROPERTY
+    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
+endif()
+
+add_library(hwy_contrib ${HWY_LIBRARY_TYPE} ${HWY_CONTRIB_SOURCES})
+target_link_libraries(hwy_contrib hwy)
 target_compile_options(hwy_contrib PRIVATE ${HWY_FLAGS})
 set_property(TARGET hwy_contrib PROPERTY POSITION_INDEPENDENT_CODE ON)
+set_target_properties(hwy_contrib PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
 target_include_directories(hwy_contrib PUBLIC ${CMAKE_CURRENT_LIST_DIR})
-
-add_library(hwy_test STATIC ${HWY_TEST_SOURCES})
+target_compile_features(hwy_contrib PUBLIC cxx_std_11)
+
+add_library(hwy_test ${HWY_LIBRARY_TYPE} ${HWY_TEST_SOURCES})
+target_link_libraries(hwy_test hwy)
 target_compile_options(hwy_test PRIVATE ${HWY_FLAGS})
 set_property(TARGET hwy_test PROPERTY POSITION_INDEPENDENT_CODE ON)
+set_target_properties(hwy_test PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
 target_include_directories(hwy_test PUBLIC ${CMAKE_CURRENT_LIST_DIR})
+target_compile_features(hwy_test PUBLIC cxx_std_11)
 
 # -------------------------------------------------------- hwy_list_targets
 # Generate a tool to print the compiled-in targets as defined by the current
@@ -219,17 +287,22 @@
 # Naked target also not always could be run (due to the lack of '.\' prefix)
 # Thus effective command to run should contain the full path
 # and emulator prefix (if any).
+if (NOT CMAKE_CROSSCOMPILING OR CMAKE_CROSSCOMPILING_EMULATOR)
 add_custom_command(TARGET hwy_list_targets POST_BUILD
     COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:hwy_list_targets> || (exit 0))
+endif()
 
 # --------------------------------------------------------
 # Allow skipping the following sections for projects that do not need them:
 # tests, examples, benchmarks and installation.
-if (HWY_EXAMPLES_TESTS_INSTALL)
 
 # -------------------------------------------------------- install library
+if (HWY_ENABLE_INSTALL)
+
 install(TARGETS hwy
-  DESTINATION "${CMAKE_INSTALL_LIBDIR}")
+  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
 # Install all the headers keeping the relative path to the current directory
 # when installing them.
 foreach (source ${HWY_SOURCES})
@@ -241,7 +314,9 @@
 endforeach()
 
 install(TARGETS hwy_contrib
-  DESTINATION "${CMAKE_INSTALL_LIBDIR}")
+  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
 # Install all the headers keeping the relative path to the current directory
 # when installing them.
 foreach (source ${HWY_CONTRIB_SOURCES})
@@ -253,7 +328,9 @@
 endforeach()
 
 install(TARGETS hwy_test
-  DESTINATION "${CMAKE_INSTALL_LIBDIR}")
+  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
 # Install all the headers keeping the relative path to the current directory
 # when installing them.
 foreach (source ${HWY_TEST_SOURCES})
@@ -272,100 +349,12 @@
       DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
 endforeach()
 
+endif() # HWY_ENABLE_INSTALL
 # -------------------------------------------------------- Examples
+if (HWY_ENABLE_EXAMPLES)
 
 # Avoids mismatch between GTest's static CRT and our dynamic.
 set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
 
 # Programming exercise with integrated benchmark
 add_executable(hwy_benchmark hwy/examples/benchmark.cc)
-target_sources(hwy_benchmark PRIVATE
-    hwy/nanobenchmark.cc
-    hwy/nanobenchmark.h)
-# Try adding either -DHWY_COMPILE_ONLY_SCALAR or -DHWY_COMPILE_ONLY_STATIC to
-# observe the difference in targets printed.
-target_compile_options(hwy_benchmark PRIVATE ${HWY_FLAGS})
-target_link_libraries(hwy_benchmark hwy)
-set_target_properties(hwy_benchmark
-    PROPERTIES RUNTIME_OUTPUT_DIRECTORY "examples/")
-
-# -------------------------------------------------------- Tests
-
-include(CTest)
-
-if(BUILD_TESTING)
-enable_testing()
-include(GoogleTest)
-
-set(HWY_SYSTEM_GTEST OFF CACHE BOOL "Use pre-installed googletest?")
-if(HWY_SYSTEM_GTEST)
-find_package(GTest REQUIRED)
-else()
-# Download and unpack googletest at configure time
-configure_file(CMakeLists.txt.in googletest-download/CMakeLists.txt)
-execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
-  RESULT_VARIABLE result
-  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
-if(result)
-  message(FATAL_ERROR "CMake step for googletest failed: ${result}")
-endif()
-execute_process(COMMAND ${CMAKE_COMMAND} --build .
-  RESULT_VARIABLE result
-  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
-if(result)
-  message(FATAL_ERROR "Build step for googletest failed: ${result}")
-endif()
-
-# Prevent overriding the parent project's compiler/linker
-# settings on Windows
-set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
-
-# Add googletest directly to our build. This defines
-# the gtest and gtest_main targets.
-add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
-                 ${CMAKE_CURRENT_BINARY_DIR}/googletest-build
-                 EXCLUDE_FROM_ALL)
-
-# The gtest/gtest_main targets carry header search path
-# dependencies automatically when using CMake 2.8.11 or
-# later. Otherwise we have to add them here ourselves.
-if (CMAKE_VERSION VERSION_LESS 2.8.11)
-  include_directories("${gtest_SOURCE_DIR}/include")
-endif()
-endif() # HWY_SYSTEM_GTEST
-
-set(HWY_TEST_FILES
-  hwy/contrib/dot/dot_test.cc
-  hwy/contrib/image/image_test.cc
-  # Disabled due to SIGILL in clang7 debug build during gtest discovery phase,
-  # not reproducible locally. Still tested via bazel build.
-  # hwy/contrib/math/math_test.cc
-  hwy/contrib/sort/sort_test.cc
-  hwy/aligned_allocator_test.cc
-  hwy/base_test.cc
-  hwy/highway_test.cc
-  hwy/targets_test.cc
-  hwy/examples/skeleton_test.cc
-  hwy/tests/arithmetic_test.cc
-  hwy/tests/blockwise_test.cc
-  hwy/tests/combine_test.cc
-  hwy/tests/compare_test.cc
-  hwy/tests/convert_test.cc
-  hwy/tests/crypto_test.cc
-  hwy/tests/logical_test.cc
-  hwy/tests/mask_test.cc
-  hwy/tests/memory_test.cc
-  hwy/tests/swizzle_test.cc
-  hwy/tests/test_util_test.cc
-)
-
-file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests)
-foreach (TESTFILE IN LISTS HWY_TEST_FILES)
-  # The TESTNAME is the name without the extension or directory.
-  get_filename_component(TESTNAME ${TESTFILE} NAME_WE)
-  add_executable(${TESTNAME} ${TESTFILE})
-  target_compile_options(${TESTNAME} PRIVATE ${HWY_FLAGS})
-  # Test all targets, not just the best/baseline. This changes the default
-  # policy to all-attainable; note that setting -DHWY_COMPILE_* directly can
-  # cause compile errors because only one may be set, and other CMakeLists.txt
-  # that include us may set them.

=== debian/changelog ===
highway (0.16.0-1) unstable; urgency=medium

  * d/rules: Make sure to check level 4 symbol file
  * d/symbols: Add symbol for 32bits arch
  * d/binaries: Specify path to PDF files
  * d/copyright: Update to latest year
  * d/compat: Bump compat to 11
  * d/control: Make sure to depends on runtime
  * New upstream version 0.16.0
  * d/symbols: Add new symbols from 0.16.0

 -- Mathieu Malaterre <malat@debian.org>  Mon, 21 Feb 2022 10:20:45 +0100

highway (0.15.1~git20220119.fbe5705-1) experimental; urgency=medium

  * New upstream version 0.15.1~git20220119.fbe5705
  * d/patches: Remove patches applied upstream
  * d/libhwy0: Provide highway as shared libraries
  * d/doc-base: Add missing doc-base registration file

 -- Mathieu Malaterre <malat@debian.org>  Thu, 20 Jan 2022 09:03:02 +0100

=== debian/control ===
Source: highway
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: cmake (>= 3.13), debhelper (>= 11), libgtest-dev, ninja-build
Standards-Version: 4.6.0
Homepage: https://github.com/google/highway
Vcs-Git: https://salsa.debian.org/debian-phototools-team/highway.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
Rules-Requires-Root: no

Package: libhwy0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Efficient and performance-portable SIMD wrapper (runtime files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the runtime files.

Package: libhwy-dev
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libhwy0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Efficient and performance-portable SIMD wrapper (developer files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the development files.

Package: highway-doc
Architecture: all
Section: doc
Depends: doc-base, ${misc:Depends}
Description: Efficient and performance-portable SIMD wrapper (documentation files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the documentation files.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,11 @@
 #!/usr/bin/make -f
+#export DH_VERBOSE=1
+
+include /usr/share/dpkg/default.mk
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
+
 %:
 	dh $@ --buildsystem=cmake+ninja
 
@@ -7,8 +14,10 @@
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=OFF
 endif
 
+# test suite rely on CMAKE_SKIP_RPATH=OFF
 CMAKE_EXTRA_FLAGS += \
- -DBUILD_SHARED_LIBS:BOOL=OFF \
+ -DCMAKE_SKIP_RPATH:BOOL=OFF \
+ -DBUILD_SHARED_LIBS:BOOL=ON \
  -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
  -DHWY_SYSTEM_GTEST:BOOL=ON

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libjxl-$1\.tar\.gz/ \
  https://github.com/google/highway/tags .*/v?(\d\S+)\.tar\.gz

## highway 0.17.0

=== debian/changelog ===
highway (0.17.0-4) unstable; urgency=medium

  * d/patches: Fix armhf compilation failure

 -- Mathieu Malaterre <malat@debian.org>  Tue, 28 Jun 2022 11:54:52 +0200

highway (0.17.0-3) unstable; urgency=medium

  * d/rules: Disable Emu128 on armhf for now, revert to Scalar
  * d/patches: Fix unit test on big-endian arches

 -- Mathieu Malaterre <malat@debian.org>  Mon, 27 Jun 2022 16:46:06 +0200

highway (0.17.0-2) unstable; urgency=medium

  * d/patches: cherry-pick a fix for arm64/armhf

 -- Mathieu Malaterre <malat@debian.org>  Wed, 22 Jun 2022 08:47:55 +0200

highway (0.17.0-1) unstable; urgency=medium

  * New upstream version 0.17.0
  * d/patches: Fix symbols mangling issue
  * d/symbols: Update symbols for new release
  * d/control: Bump Std-Vers to 4.6.1 no changes needed
  * d/rules: Remove some CPU extension on i386

 -- Mathieu Malaterre <malat@debian.org>  Tue, 21 Jun 2022 17:13:46 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
 Build-Depends: cmake (>= 3.13), debhelper (>= 11), libgtest-dev, ninja-build
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/google/highway
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/highway.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,14 @@
 ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),armhf))
   # https://github.com/google/highway/issues/495
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=OFF
+  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
+  # https://github.com/google/highway/issues/398#issuecomment-1167331556
+  export DEB_CXXFLAGS_MAINT_APPEND = -Wno-psabi -DHWY_COMPILE_ONLY_SCALAR
+endif
+
+# Disable some extensions on i386 anyway:
+ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),i386))
+  export DEB_CXXFLAGS_MAINT_APPEND = -DHWY_DISABLED_TARGETS='(HWY_SSE4|HWY_SSSE3)'
 endif
 
 # test suite rely on CMAKE_SKIP_RPATH=OFF
